# Documentation

Menu

## Application

### Interfaces, Classes, Traits and Enums

DriverInterface
  PDO Interface to implement for database drivers
SQLInterface
  Interface for database-specific syntax subclasses
QueryBuilderInterface
  Interface defining the Query Builder class
ConnectionManager
  Connection manager class to manage connections for the Query method
AbstractDriver
  Base Database class
AbstractSQL
  Parent for database-specific syntax subclasses
AbstractUtil
  Abstract class defining database / table creation methods
Driver
  MySQL specific class
SQL
  MySQL specific SQL
Util
  MySQL-specific backup, import and creation methods
Driver
  PostgreSQL specific class
SQL
  PostgreSQL specific SQL
Util
  Postgres-specific backup, import and creation methods
Driver
  SQLite specific class
SQL
  SQLite Specific SQL
Util
  SQLite-specific backup, import and creation methods
BadDBDriverException
  Generic exception for bad drivers
NonExistentConnectionException
  Exception for missing database connection
NotImplementedException
  Exception for non-implemented method
QueryBuilder
  Convenience class for creating sql queries
QueryBuilderBase
QueryParser
  Utility Class to parse sql clauses for properly escaping identifiers
State
  Query builder state

### Table of Contents

mb_trim() : string
  Multibyte-safe trim function
dbFilter() : array<string|int, mixed>
  Filter out db rows into one array
arrayZipper() : array<string|int, mixed>
  Zip a set of arrays together on common keys
regexInArray() : bool
  Determine whether a value in the passed array matches the pattern passed
Query() : QueryBuilderInterface|null
  Connection function

### Functions

#### mb_trim()

common.php : 26

Multibyte-safe trim function

`mb_trim(string $string) : string`

##### Parameters

$string : string

##### Return values

string —

#### dbFilter()

common.php : 34

Filter out db rows into one array

`dbFilter(array<string|int, mixed> $array, mixed $index) : array<string|int, mixed>`

##### Parameters

$array : array<string|int, mixed>
$index : mixed

##### Return values

array<string|int, mixed> —

#### arrayZipper()

common.php : 52

Zip a set of arrays together on common keys

`arrayZipper(array<string|int, mixed> $zipperInput) : array<string|int, mixed>`

The $zipperInput array is an array of arrays indexed by their place in the output array.

##### Parameters

$zipperInput : array<string|int, mixed>

##### Return values

array<string|int, mixed> —

#### regexInArray()

common.php : 75

Determine whether a value in the passed array matches the pattern passed

`regexInArray(array<string|int, mixed> $array, string $pattern) : bool`

##### Parameters

$array : array<string|int, mixed>
$pattern : string

##### Return values

bool —

#### Query()

common.php : 101

Connection function

`Query([string|object|array<string|int, mixed>|null $params = '' ]) : QueryBuilderInterface|null`

Send an array or object as connection parameters to create a connection. If the array or object has an 'alias' parameter, passing that string to this function will return that connection. Passing no parameters returns the last connection created.

##### Parameters

$params : string|object|array<string|int, mixed>|null = ''

##### Return values

QueryBuilderInterface|null —

## Search results